/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2021 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "filter_proj_float.h"
#include "i2s_transfer.h"
#include "i2c-codec.h"
#include "string.h"
#include "serLCD.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

I2C_HandleTypeDef hi2c1;

I2S_HandleTypeDef hi2s2;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_I2S2_Init(void);
static void MX_I2C1_Init(void);
/* USER CODE BEGIN PFP */
static float gains[8] = {0, 1, 2, 3, 4, 5, 6, 7};
static float center_frequencies[8] = {125, 250, 500, 1000, 2000, 4000, 8000, 14000};
static float band_widths[8] = {1.0, 0.75, 0.75, 0.75, 0.75, 0.75, 0.75, 1.0};
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_I2S2_Init();
  MX_I2C1_Init();
  /* USER CODE BEGIN 2 */

  // displayInit(&hi2c1);
  HAL_StatusTypeDef result;
  result = codec_init(&hi2c1);
  result = codec_test(&hi2c1);
  /*
  displayHome();
  displayWriteString("Initializing Portizer.");
  HAL_Delay(1000);
  displayWriteString(".");
  HAL_Delay(1000);
  displayWriteString(".");
  HAL_Delay(1000);
  HAL_Delay(1000);
  displayClear();
  displayWriteString("Device Initialized");
  HAL_Delay(4000);
  displayClear();
  displayWriteString("Enter Frequency :   ");
  displayWriteString("100 ");
  HAL_Delay(1400);
  displayWriteString("250 ");
  HAL_Delay(1400);
  displayWriteString("500 ");
  HAL_Delay(1400);
  displayClear();
  displayWriteString("Frequency : 500 ");
  HAL_Delay(1400);
  displayClear();
  displayWriteString("Enter dB Level : ");
  HAL_Delay(1400);
  displayWriteString("+1 ");
  HAL_Delay(1433);
  displayWriteString("+2 ");
  HAL_Delay(1433);
  displayWriteString("+3 ");
  HAL_Delay(1433);
  displayClear();
  displayWriteString("dB level : +3 ");
  */
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
// int audio_signal[FS*NUM_SECONDS];
uint32_t fb_start, fb_end, mcu_start, mcu_end, ff_start, ff_end, loop_start, loop_end;
int c = (FS/2)/NUM_SECONDS;
// for (int i = 0; i < FS*NUM_SECONDS; ++i)
//	audio_signal[i] = sin(2*M_PI*(c/2*pow((i/FS), 2)))*VOLUME;
int i = 0, i_end = 3;
float freq_alter_right[audio_len];
float freq_alter_left[audio_len];
arm_fill_f32(0, freq_alter_right, audio_len);
arm_fill_f32(0, freq_alter_left, audio_len);
// memset(freq_alter_right, 0, audio_len*sizeof(float));
// memset(freq_alter_left, 0, audio_len*sizeof(float));

float final_signal_right[audio_len];
float final_signal_left[audio_len];
arm_fill_f32(0, final_signal_right, audio_len);
arm_fill_f32(0, final_signal_left, audio_len);
// memset(final_signal_right, 0, audio_len*sizeof(float));
// memset(final_signal_left, 0, audio_len*sizeof(float));

int sig_track = 0;
float complex filterbank[num_bands][n_freqs];
float complex big_filter[n_freqs];
construct_filterbank(gains, center_frequencies, band_widths, FS, filterbank, big_filter);
// initialize_with_chirp(freq_alter_right, sig_track, fft_size, c);
// sig_track = initialize_with_chirp(freq_alter_left, sig_track, fft_size, c);
initialize_with_chirp(freq_alter_right+hop, sig_track, buffer_slice, c);
sig_track = initialize_with_chirp(freq_alter_left+hop, sig_track, buffer_slice, c);

// while (1)
for (i = 0; i < 100; ++i)
{
	loop_start = HAL_GetTick();
	// if (sig_track <= buffer_slice)
	// 	fs_start = HAL_GetTick();
	// if (sig_track > FS)
	// {
	// 	fs_end = HAL_GetTick();
	// 	fs_start = HAL_GetTick();
	// }
	// if(FS*NUM_SECONDS - sig_track <= buffer_add)
	if(FS*NUM_SECONDS - sig_track <= fft_size)
		sig_track = 0;

	ff_start = HAL_GetTick();
	// fast_filter(freq_alter_right, final_signal_right, filterbank);
	// fast_filter(freq_alter_left, final_signal_left, filterbank);
	ff_end = HAL_GetTick();
	mcu_start = HAL_GetTick();
	filter_input(freq_alter_right, final_signal_right, big_filter);
	filter_input(freq_alter_left, final_signal_left, big_filter);
	mcu_end = HAL_GetTick();

	// HAL_StatusTypeDef res = receive_I2S(&hi2s2, final_signal_right+hop, final_signal_left+hop, buffer_add);
	// HAL_StatusTypeDef res = transmit_I2S(&hi2s2, final_signal_right, final_signal_left, fft_size);
	ff_start = HAL_GetTick();
	HAL_StatusTypeDef res = transmit_I2S(&hi2s2, final_signal_right+hop, final_signal_left+hop, buffer_add);
	ff_end = HAL_GetTick();
	// HAL_StatusTypeDef res = transmit_I2S(&hi2s2, freq_alter_right+hop, freq_alter_left+hop, buffer_add);
	if (res != HAL_OK)
		Error_Handler();
	arm_copy_f32(freq_alter_right+buffer_add, freq_alter_right, fft_size);
	arm_copy_f32(freq_alter_left+buffer_add, freq_alter_left, fft_size);

	arm_fill_f32(0, final_signal_right, audio_len);
	arm_fill_f32(0, final_signal_left, audio_len);

	initialize_with_chirp(freq_alter_right+fft_size, sig_track, buffer_add, c);
	sig_track = initialize_with_chirp(freq_alter_left+fft_size, sig_track, buffer_add, c);
	// initialize_with_chirp(freq_alter_right, sig_track, fft_size, c);
	// sig_track = initialize_with_chirp(freq_alter_left, sig_track, fft_size, c);

	// sig_track += buffer_add;
	loop_end = HAL_GetTick();
    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
}
// mcu_end = HAL_GetTick();
// mcu_start = HAL_GetTick();
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Supply configuration update enable
  */
  HAL_PWREx_ConfigSupply(PWR_LDO_SUPPLY);
  /** Configure the main internal regulator output voltage
  */
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE3);

  while(!__HAL_PWR_GET_FLAG(PWR_FLAG_VOSRDY)) {}
  /** Macro to configure the PLL clock source
  */
  __HAL_RCC_PLL_PLLSOURCE_CONFIG(RCC_PLLSOURCE_HSI);
  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_DIV1;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLM = 4;
  RCC_OscInitStruct.PLL.PLLN = 25;
  RCC_OscInitStruct.PLL.PLLP = 2;
  RCC_OscInitStruct.PLL.PLLQ = 2;
  RCC_OscInitStruct.PLL.PLLR = 2;
  RCC_OscInitStruct.PLL.PLLRGE = RCC_PLL1VCIRANGE_3;
  RCC_OscInitStruct.PLL.PLLVCOSEL = RCC_PLL1VCOWIDE;
  RCC_OscInitStruct.PLL.PLLFRACN = 0;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2
                              |RCC_CLOCKTYPE_D3PCLK1|RCC_CLOCKTYPE_D1PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.SYSCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB3CLKDivider = RCC_APB3_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_APB1_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_APB2_DIV1;
  RCC_ClkInitStruct.APB4CLKDivider = RCC_APB4_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.Timing = 0x00C0EAFF;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.OwnAddress2Masks = I2C_OA2_NOMASK;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Analogue filter
  */
  if (HAL_I2CEx_ConfigAnalogFilter(&hi2c1, I2C_ANALOGFILTER_ENABLE) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Digital filter
  */
  if (HAL_I2CEx_ConfigDigitalFilter(&hi2c1, 0) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief I2S2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2S2_Init(void)
{

  /* USER CODE BEGIN I2S2_Init 0 */

  /* USER CODE END I2S2_Init 0 */

  /* USER CODE BEGIN I2S2_Init 1 */

  /* USER CODE END I2S2_Init 1 */
  hi2s2.Instance = SPI2;
  hi2s2.Init.Mode = I2S_MODE_MASTER_TX;
  hi2s2.Init.Standard = I2S_STANDARD_PHILIPS;
  hi2s2.Init.DataFormat = I2S_DATAFORMAT_24B;
  hi2s2.Init.MCLKOutput = I2S_MCLKOUTPUT_DISABLE;
  hi2s2.Init.AudioFreq = I2S_AUDIOFREQ_44K;
  hi2s2.Init.CPOL = I2S_CPOL_LOW;
  hi2s2.Init.FirstBit = I2S_FIRSTBIT_MSB;
  hi2s2.Init.WSInversion = I2S_WS_INVERSION_DISABLE;
  hi2s2.Init.Data24BitAlignment = I2S_DATA_24BIT_ALIGNMENT_LEFT;
  hi2s2.Init.MasterKeepIOState = I2S_MASTER_KEEP_IO_STATE_DISABLE;
  if (HAL_I2S_Init(&hi2s2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2S2_Init 2 */

  /* USER CODE END I2S2_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOB_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
